#include "bresenham.h"

void dessine_ligne(Point& A,Point& B,Ecran_SDL& s,Couleur& c){
  //Dans quel octant se trouve le segment ?
  int dx=B.x-A.x;
  int dy=B.y-A.y;
  if(dx<0){
    //Octant 3 ou 4 ou 5 ou 6
    return dessine_ligne(B,A,s,c);
  }
  //octant 1 ou 2 ou 7 ou 8
  int delta;
  Point P;
  if(dy>0){
    //octant 1 ou 2
    if(dx>dy){
      //***********************************
      //* -----> Cas de l'octant 1 <----- *
      //* Un point par ligne              *
      //* Point suivant : E ou NE         *
      //* Si delta > 0 : NE               *
      //* Si delta <=0 : E                *
      //* delta_0 = 2 F_D(A.x+1,A.y+0.5)  *
      //*         = 2dy-dx                *
      //* delta_E = 2dy                   *
      //* delta_NE =2dy-2dx               *
      //***********************************
      delta=2*dy-dx;
      int delta_E=2*dy;
      int delta_NE=2*dy-2*dx;
      P.y=A.y;
      for(P.x=A.x;P.x<=B.x;++P.x){
	if(delta>0){
	  ++P.y;
	  delta+=delta_NE;
	}
	else{
	  delta+=delta_E;
	}
	s.dessine_point(P,c);
      }
    }
    else{
      //***********************************
      //* -----> Cas de l'octant 2 <----- *
      //* Un point par ligne              *
      //* Point suivant : N ou NE         *
      //* Si delta > 0 : N                *
      //* Si delta <=0 : NE               *
      //* delta_0 = 2 F_D(A.x+0.5,A.y+1)  *
      //*         = 2dx-dy                *
      //* delta_N = 2dx                   *
      //* delta_NE =2dy-2dx               *
      //***********************************
      delta=dy-2*dx;
      int delta_N=-2*dx;
      int delta_NE=2*dy-2*dx;
      P.x=A.x;
      for(P.y=A.y;P.y<=B.y;++P.y){
	if(delta>0){
	  delta+=delta_N;
	}
	else{
	  ++P.x;
	  delta+=delta_NE;
	}
	s.dessine_point(P,c);
      }
    }
  }
  else{
    //octant 7 ou 8
    if(dx>-dy){
      //***********************************
      //* -----> Cas de l'octant 7 <----- *
      //* Un point par colonne            *
      //* Point suivant : E ou SE         *
      //* Si delta > 0 : E                *
      //* Si delta <=0 : SE               *
      //* delta_0 = 2 F_D(A.x+1,A.y-0.5)  *
      //*         = 2dy+dx                *
      //* delta_E = 2dy                   *
      //* delta_SE = 2dy+2dx              *
      //***********************************
      delta=2*dy+dx;
      int delta_E=2*dy;
      int delta_SE=2*dy+2*dx;
      P.y=A.y;
      for(P.x=A.x;P.x<=B.x;++P.x){
	if(delta>0){
	  delta+=delta_E;
	}
	else{
	  --P.y;
	  delta+=delta_SE;
	}
	s.dessine_point(P,c);
      }
    }
    else{
       //***********************************
      //* -----> Cas de l'octant 8 <----- *
      //* Un point par ligne              *
      //* Point suivant : S ou SE         *
      //* Si delta > 0 : SE               *
      //* Si delta <=0 : S                *
      //* delta_0 = 2 F_D(A.x+0.5,A.y-1)  *
      //*         = dy+2dx                *
      //* delta_S = 2dx                   *
      //* delta_SE = 2dy+2dx              *
      //***********************************
      delta=dy+2*dx;
      int delta_S=2*dx;
      int delta_SE=2*dy+2*dx;
      P.x=A.x;
      for(P.y=A.y;P.y>=B.y;--P.y){
	if(delta>0){
	  ++P.x;
	  delta+=delta_SE;
	}
	else{
	  delta+=delta_S;
	}
	s.dessine_point(P,c);
      }
     }
  }
}
